       *>=IEFTIOT1 Macro ================================DSA 09/20/96
       *> MVS TIOT and storage for JFCBs may or may not follow the
       *> ISA. Their size is detemined by the number of DD
       *> statements and can vary from job to job although we may
       *> allocate space for maximum number possible and keep
       *> updating as necessary
       *>  - unless otherwise stated, all data is S/390 style
       *>
       *> Copyright (C) 1996-2005 Micro Focus International Ltd.
       *>============================================================
       01 (tag).
        03 (tag)-jobname    pic x(8).
         03 filler.
            05 (tag)-union-1.
               07 (tag)-procstep pic x(8). *> proc step name if jobstep
                                           *>       is a proc step
               07 (tag)-jobstep pic x(8).  *> Job step name calling
                                           *> proc step
            05 filler redefines (tag)-union-1.
               07 (tag)-jobstepn pic x(8). *> job step name if job step
                                           *>   is not a proc step
               07 (tag)-rsvd    pic x(8).  *> blanks
       *>03 (tag)-1st-entry     pic x(0).  *> Begins here
         78 (tag)-1st-entry     value 24.

       *>============================================================
       *>  TIOT - Task I/O Table entry
       *> - First entry start at TIOT_1st_entry, others follow
       *>           each other.
       *> - only 40 bytes mapped for each entry
       *>============================================================
       01 (tag)entry.
        03 filler.
           05 (tag)entry-union-1 pic x(20).
            05 filler redefines (tag)entry-union-1.
               07 (tag)e-len    pic 9(2) comp. *> len of this ent
               07 filler        pic x(2).
               07 filler.
                  09 (tag)entry-flags1 pic x(1) comp-x.
                     *>Bit definitions
                     78 (tag)e-nonempty-sysout value h'80'.
                     78 (tag)e-term            value h'20'.
                     78 (tag)e-dynam           value h'10'.
                     78 (tag)e-sysin           value h'04'.
                     78 (tag)e-sysout          value h'02'.
               07 (tag)e-ddn    pic x(8).
               07 filler.                  *> ptr to the JFCB - one of
                  09 (tag)-jfcb   pointer. *> If 3-byte addrs are
                                           *> 4-byte addresses. Flags
                                           *> PSA_4byte_addrs, and
                                           *> CVT_4byte_addrs = on
                  09 (tag)-jfcb-3byte pic 9(9) comp
                                                  redefines (tag)-jfcb.
                                           *> if 3-byte addrs
                                           *> are in effect. last byte=0
                  09 (tag)-jfcb-3char pic x(3) redefines (tag)-jfcb.
               07 filler.
                  09 (tag)entry-flags2 pic x(1) comp-x.
                     *>Bit definitions
                     78 (tag)e-sused          value h'80'.
                     78 (tag)e-volser-present value h'10'.
               07 filler        pic x(3).   *> 3-byte UCB address
            05 filler redefines (tag)entry-union-1.
               07 (tag)end      pic x(4). *> = zeros

       *>===============================================================
