#!/bin/sh
# rds 11 August 2006    
# Generic Script to install License Management Software. 

test `uname -s` = Linux && echocmd="echo -e" || echocmd="echo"

# ******** Ensure that the following variable always contains the version no
# ******** of the current License Manager.
THISVER=129
#*********

if test ! -w /etc/passwd
then
	$echocmd "root łȂ΂̃XNvg͎sł܂"
	exit 1
fi

set +u

unset COBPATH
unset COBDATA

COBSW=""
export COBSW

WARN=0
COBDIR=`pwd`
export COBDIR

LD_LIBRARY_PATH=$COBDIR/lib:$LD_LIBRARY_PATH:/lib
export LD_LIBRARY_PATH

# Initialise ASLM if used
if test -x ./initaslm
then
	./initaslm
else
	if test -x ../aslmf/initaslm
	then
		../aslmf/initaslm
	fi
fi

OLDVERNO=`./lmfgetpv v`
if test "$OLDVERNO." != "."
then
	ADMINDIR=`./lmfgetpv p`

# update existing PRODFILE if located
	if test "$ADMINDIR." != "."
	then
		./lmfgetpv i $ADMINDIR
# now copy it to this directory for later use
		if test "$?" = "0"
		then
			cp $ADMINDIR/PRODFILE .
		fi
	fi

	if test "$ADMINDIR." = "."
	then
# license manager running, but its launch directory no longer exists 
		if test "$OLDVERNO" -lt "$THISVER"
		then
			$echocmd "\n"
			$echocmd "݁Ão[WÂ License Manager "
			$echocmd "VXeœ삵Ă܂B"
	        fi

		if test "$OLDVERNO" -eq "$THISVER"
		then
			$echocmd "\n"
			$echocmd "݁Ão[WÂ\̂ License Manager "
			$echocmd "VXeœ삵Ă܂B"
		fi

		if test "$OLDVERNO" -gt "$THISVER"
		then     
			$echocmd "\n"
			$echocmd "݁Ão[WV License Manager "
			$echocmd "VXeœ삵Ă܂B"
		fi

		$echocmd "A[h̃fBNgɑ݂܂B\n"
        	$echocmd "ݓ쒆 License Manager ~܂? (y/n)"
        	read y
	        case "$y" in
               		y*|Y*)  ./lmfgetpv k
	                       $echocmd "\nLicense Manager ~\n"
                       		;;
                        *)      ;;
        	esac

               $echocmd "\ño[W License Manager ̃CXg[𑱂܂ (y/n)?"
               read y
               case "$y" in
                   y*|Y*)  OLDVERNO=
	                   ADMINDIR=
                           ;;
                   *)      exit 1
                           ;;
               esac
	fi
fi

if test "$OLDVERNO." != "."
then
	if test "$OLDVERNO" -lt "$THISVER"
# license manager running, and its launch directory is located        
	then
		$echocmd "\n"
		$echocmd "݁Ão[WÂ License Manager "
		$echocmd "VXeœ삵Ă܂B́A $ADMINDIR ɃCXg["
		$echocmd "Ă܂B\n"
                $echocmd "̃o[WCXg[ăAbvO[h邱Ƃ߂܂B"
                $echocmd "̃CXg[ς݃CZX͂̂܂܂ŉe͎󂯂܂B"
		$echocmd "̐Vo[W License Manager CXg[ꍇ́A"
        fi

	if test "$OLDVERNO" -eq "$THISVER"
	then
		$echocmd "\n"
		$echocmd "݁Ão[WÂ\̂ License Manager "
		$echocmd "VXeœ삵Ă܂B́A $ADMINDIR ɃCXg["
		$echocmd "Ă܂B\n"
                $echocmd "̃o[WCXg[ăAbvO[h邱Ƃ߂܂B"
                $echocmd "̃CXg[ς݃CZX͂̂܂܂ŉe͎󂯂܂B"
		$echocmd "̐Vo[W License Manager CXg[ꍇ́A"
        fi

	if test "$OLDVERNO" -gt "$THISVER"
	then     
		$echocmd "\n"
		$echocmd "݁Ão[WV License Manager "
		$echocmd "VXeœ삵Ă܂B́A $ADMINDIR ɃCXg["
		$echocmd "Ă܂B\n"
		$echocmd "ɓ삵Ă̂Âo[W License Manager "
		$echocmd "CXg[悤ƂĂ܂B\n"
		$echocmd "ł̌Âo[W License Manager CXg[ꍇ́A"
        fi

	$echocmd "$ADMINDIR ɃCXg[܂Bݓ쒆̃o[W͒~Ȃ΂܂B\n"
	$echocmd "$ADMINDIR ɃCXg[܂\n"
        $echocmd "(ɂ茻ݓ쒆 License Manager ͒~܂) ? (y/n)"
        read y
        case "$y" in
               y*|Y*)  ./lmfgetpv k
		       while test -w "$ADMINDIR/mflm_manager"
		       do
			    rm $ADMINDIR/mflm_manager
		       done
                       $echocmd "\nLicense Manager ~\n"
                       ;;
               *)      $echocmd "\n̐Vo[W License Manager "
                       $echocmd "$ADMINDIR Ƃ͈ႤfBNgɃCXg[܂? (y/n)"
                       read y
                       case "$y" in
                           y*|Y*)  OLDADMINDIR=$ADMINDIR
                                   ADMINDIR=
                                   ;;
                           *)      exit 1
                                   ;;
                       esac
			;;
        esac
fi
if test "$ADMINDIR." = "."
then
	WARN=1

	DEFDIR="/opt/microfocus/mflmf"

	INVALID=TRUE
	while test "$INVALID" = "TRUE"
	do
		$echocmd "\nLicense Manager CXg[fBNg͂Ă"
		$echocmd "(ftHgfBNg $DEFDIR ɂꍇ Enter Ă)"  
		INVALID=FALSE
		read ADMINDIR

		if test "$ADMINDIR" = "`pwd`"
		then
			INVALID=TRUE
			$echocmd "̃fBNgɂ̓CXg[ł܂"
		fi

		if test "$ADMINDIR" = "."
		then
			INVALID=TRUE
			$echocmd "̃fBNgɂ̓CXg[ł܂"
		fi

		if test "$ADMINDIR" = "./"
		then
			INVALID=TRUE
			$echocmd "̃fBNgɂ̓CXg[ł܂"
		fi
		if expr "$ADMINDIR" : '[^\/]' > /dev/null
		then
			INVALID=TRUE
			$echocmd "'/' Ŏn܂΃pX͂ĂB"
		fi
	done


	if test "$ADMINDIR." = "."
	then
		ADMINDIR=$DEFDIR
	fi

        if test "$OLDADMINDIR" = "$ADMINDIR"
        then
           $echocmd "License Manager ~ȂƁAɂ̓CXg[ł܂!"
           exit 1
        fi

	if test ! -d "$ADMINDIR"
	then
		$echocmd "$ADMINDIR ݂͑܂B"
		$echocmd "쐬܂? (y/n) "
		read y
		case "$y" in
			y*|Y*)	mkdir -p $ADMINDIR
				chmod 777 $ADMINDIR
				;;
			*)	ADMINDIR=
				exit 1
				;;
		esac
	fi
fi

# Check this version no against version in install directory (if any)
if test "$WARN" = "1"
then
  if test -f $ADMINDIR/LMFVERNO
  then
	OLDVERNO=`cat $ADMINDIR/LMFVERNO`
	if test "$OLDVERNO" -gt "$THISVER"
	then     
		$echocmd "\n"
		$echocmd "̃o[WV License Manager "
		$echocmd " $ADMINDIR ɃCXg["
		$echocmd "Ă܂B\n"
		$echocmd "ɃCXg[ς݂̂Âo[W License Manager "
		$echocmd "CXg[悤ƂĂ܂B\n"
		INVALID=TRUE
		while test "$INVALID" = "TRUE"
		do
        		$echocmd "$ADMINDIR ɃCXg[𑱂܂ (y/n) "
		        read y
       			case "$y" in
       	        		y*|Y*)  INVALID=FALSE
                                   ;;
       	        		n*|N*)  exit 1
                                   ;;
	                        *)      ;;
                       esac
		done
        fi
  fi
fi

if test ! -d $ADMINDIR/lib
then	
	mkdir $ADMINDIR/lib
	chmod 777 $ADMINDIR/lib
fi
if test ! -d $ADMINDIR/terminfo
then
	mkdir $ADMINDIR/terminfo
	chmod 777 $ADMINDIR/terminfo
fi


# update/create PRODFILE 
./lmfgetpv i $ADMINDIR
 
# now copy it to this directory so tar doesn't overwrite it
if test "$?" = "0"
then
	cp $ADMINDIR/PRODFILE .
fi

# delete any db that may have been previously created by user trying to
# use this directory as his lmf install directory. Failure to do this will
# cause this db to be installed as an invalid db to the lmf install directory. 

OLDDB=0
if test -f ./mflmfdb
then
	OLDDB=1
fi
if test -f ./mflmfdb.idx
then
	OLDDB=1
fi
if test -f ./mflmfdbX
then
	OLDDB=1
fi
if test -f ./mflmfdbX.idx
then
	OLDDB=1
fi
if test "$OLDDB" = "1"
then
	$echocmd "\n"
	$echocmd "JgfBNgɗ\ȂCZXf[^x[X݂Ă܂B"
	INVALID=TRUE
	while test "$INVALID" = "TRUE"
	do
		$echocmd "̃f[^x[X폜ĂCXg[𑱍s܂? (y/n) "
	        read y
		case "$y" in
               		y*|Y*)  INVALID=FALSE
                                rm ./mflmfdb*
                                ;;
        		n*|N*)  exit 1
                                ;;
               		*) 	;;
                esac
	done
fi


# cp -r * $ADMINDIR
# use tar instead of cp to maintain links

tar cf - . | (cd $ADMINDIR ; tar xf - )

if test ! -f $ADMINDIR/mflmfdb
then
	cd $ADMINDIR
	./bin/rts32 lmfnewdb
fi	
 
# create empty log/backup files now so restricted access not a problem
touch $ADMINDIR/mflm-history
touch $ADMINDIR/MF-LMF.log
touch $ADMINDIR/mflmfdbX
touch $ADMINDIR/mflmfdbX.idx

# create an LMFVERNO file
$echocmd $THISVER > $ADMINDIR/LMFVERNO

rm $ADMINDIR/lmfinstall

$echocmd "X[p[UCZXǗVXeɃANZXł悤ɂ܂? (y/n)"
read y
case "$y" in
	y*|Y*)  chmod 700 $ADMINDIR
      		;;
	*)      ;;
esac

chmod 555 $ADMINDIR/*
chmod 544 $ADMINDIR/mflm_manager
chmod 777 $ADMINDIR/mflmfdb*

$echocmd "echo Starting MFLM License Manager" > $ADMINDIR/mflmrcscript
$echocmd "COBDIR=$ADMINDIR" >> $ADMINDIR/mflmrcscript
$echocmd "export COBDIR" >> $ADMINDIR/mflmrcscript
 
$echocmd "LD_LIBRARY_PATH=\$COBDIR/lib:\$LD_LIBRARY_PATH:/lib" >> $ADMINDIR/mflmrcscript
$echocmd "export LD_LIBRARY_PATH" >> $ADMINDIR/mflmrcscript


$echocmd "cd $ADMINDIR" >> $ADMINDIR/mflmrcscript

$echocmd "./mflm_manager" >> $ADMINDIR/mflmrcscript
chmod 755 $ADMINDIR/mflmrcscript

$echocmd "License Manager u[gɎŋN邱Ƃ𐄏܂B"
$echocmd "License Manager u[gɎŋN܂? (y/n)"
read y
case "$y" in
	y*|Y*)	
			cp $ADMINDIR/mflmrcscript /etc
			chmod 755 /etc/mflmrcscript
                        cp /etc/inittab /etc/inittab.bak
			check=`grep mflmrcscript /etc/inittab`
			if [ ! -z "$check" ]
			then
				fgrep -v "mflmrcscript" /etc/inittab.bak > /etc/inittab
			fi
 			$echocmd "mF:2345:wait:sh /etc/mflmrcscript > /dev/null 2>&1" >> /etc/inittab
       		;;

	*)	$echocmd "\nLicense Manager u[gŋNɂ́A"
                $echocmd "$ADMINDIR/mflmrcscript  /etc ɃRs[āA"
		$echocmd "t@C /etc/inittab Ɉȉ̃GgǉĂB:"
		$echocmd "mF:2345:wait:sh /etc/mflmrcscript > /dev/null 2>&1"
		$echocmd "\nڍׂ́Agp OS ̃}jAQƂĂB\n"
		;;
esac
	
$echocmd $ADMINDIR > /tmp/lmfinstalldir
$echocmd "LMF ̃CXg[܂B\n"
